diff -r -c bash-1_14_7/.distribution bash1147/.distribution
*** bash-1_14_7/.distribution	Wed Mar 10 09:43:44 1999
--- bash1147/.distribution	Wed Mar 10 09:44:50 1999
***************
*** 1 ****
! 1.14
--- 1 ----
! 1.15
diff -r -c bash-1_14_7/bashhist.c bash1147/bashhist.c
*** bash-1_14_7/bashhist.c	Wed Mar 10 09:43:45 1999
--- bash1147/bashhist.c	Fri Mar 19 17:36:13 1999
***************
*** 106,111 ****
--- 106,114 ----
    /* Read the history in HISTFILE into the history list. */
    hf = get_string_value ("HISTFILE");
  
+ #if defined (USE_VMS)
+   hf = vmsutil_expand_path (savestring (hf));
+ #endif
    if (hf && *hf)
      {
        struct stat buf;
***************
*** 117,122 ****
--- 120,129 ----
  	  history_lines_in_file = where_history ();
  	}
      }
+ #if defined (USE_VMS)
+   if (hf)
+     free (hf);
+ #endif
  }
  
  /* Write the existing history out to the history file. */
***************
*** 125,130 ****
--- 132,140 ----
  {
    char *hf = get_string_value ("HISTFILE");
  
+ #if defined (USE_VMS)
+   hf = vmsutil_expand_path (savestring (hf));
+ #endif
    if (hf && *hf)
      {
        struct stat buf;
***************
*** 141,146 ****
--- 151,160 ----
  	    write_history (hf);
  	}
      }
+ #if defined (USE_VMS)
+   if (hf)
+     free (hf);
+ #endif
  }
  
  /* If this is an interactive shell, then append the lines executed
***************
*** 154,159 ****
--- 168,176 ----
      {
        char *hf = get_string_value ("HISTFILE");
  
+ #if defined (USE_VMS)
+       hf = vmsutil_expand_path (savestring (hf));
+ #endif
        if (hf && *hf)
  	{
  	  struct stat buf;
***************
*** 182,187 ****
--- 199,208 ----
  	    }
  	  history_lines_this_session = 0;
  	}
+ #if defined (USE_VMS)
+       if (hf)
+ 	free (hf);
+ #endif
      }
    return (result);
  }
diff -r -c bash-1_14_7/builtins/cd.def bash1147/builtins/cd.def
*** bash-1_14_7/builtins/cd.def	Wed Mar 10 09:43:50 1999
--- bash1147/builtins/cd.def	Wed Mar 10 09:45:00 1999
***************
*** 22,28 ****
--- 22,30 ----
  $PRODUCES cd.c
  
  #include <stdio.h>
+ #ifndef VMS
  #include <sys/param.h>
+ #endif
  
  #if defined (HAVE_STRING_H)
  #  include <string.h>
diff -r -c bash-1_14_7/builtins/exit.def bash1147/builtins/exit.def
*** bash-1_14_7/builtins/exit.def	Wed Mar 10 09:43:51 1999
--- bash1147/builtins/exit.def	Fri Mar 19 15:18:18 1999
***************
*** 37,42 ****
--- 37,47 ----
  
  extern int interactive, login_shell;
  extern int last_command_exit_value;
+ #if defined (USE_VMS)
+ int subshell_exit_value = 0;
+ int subshell_exit_builtin = 0;
+ int subshell_skip_commands = 0;
+ #endif
  
  static int exit_or_logout ();
  static int sourced_logout = 0;
***************
*** 120,129 ****
--- 125,149 ----
  
    /* Run our `~/.bash_logout' file if it exists, and this is a login shell. */
    if (login_shell && sourced_logout++ == 0)
+ #if defined (USE_VMS)
+     if (maybe_execute_file ("sys$login:.bash_logout", 1) == 0)
+       if (maybe_execute_file ("sys$login:_bash_logout", 1) == 0)
+         maybe_execute_file ("sys$login:_blogout", 1);
+ #else
      maybe_execute_file ("~/.bash_logout", 1);
+ #endif
  
    last_command_exit_value = exit_value;
  
    /* Exit the program. */
+ #if defined (USE_VMS)
+   if (subshell_exit_builtin)
+     {
+       subshell_exit_value = exit_value;
+       subshell_exit_builtin = 0;
+       subshell_skip_commands = 1;
+       return (EXECUTION_SUCCESS);
+     }
+ #endif
    longjmp (top_level, EXITPROG);
  }
diff -r -c bash-1_14_7/builtins/fc.def bash1147/builtins/fc.def
*** bash-1_14_7/builtins/fc.def	Wed Mar 10 09:43:51 1999
--- bash1147/builtins/fc.def	Wed Mar 10 09:45:02 1999
***************
*** 50,59 ****
--- 50,65 ----
  #include "../bashansi.h"
  #include "../shell.h"
  #if defined (HISTORY)
+ #ifdef VMS
+ #include <types.h>
+ #include <stat.h>
+ #include <file.h>
+ #else
  #include <sys/param.h>
  #include <sys/types.h>
  #include <sys/stat.h>
  #include <sys/file.h>
+ #endif
  #include <errno.h>
  #include "../builtins.h"
  #include "../flags.h"
diff -r -c bash-1_14_7/builtins/history.def bash1147/builtins/history.def
*** bash-1_14_7/builtins/history.def	Wed Mar 10 09:43:51 1999
--- bash1147/builtins/history.def	Wed Mar 10 09:45:03 1999
***************
*** 37,44 ****
--- 37,49 ----
  
  #include "../shell.h"
  #if defined (HISTORY)
+ #ifdef VMS
+ #include <types.h>
+ #include <file.h>
+ #else
  #include <sys/types.h>
  #include <sys/file.h>
+ #endif
  #include "../filecntl.h"
  #include "../posixstat.h"
  #include "../bashhist.h"
diff -r -c bash-1_14_7/builtins/mkbuiltins.c bash1147/builtins/mkbuiltins.c
*** bash-1_14_7/builtins/mkbuiltins.c	Wed Mar 10 09:43:52 1999
--- bash1147/builtins/mkbuiltins.c	Wed Mar 10 09:45:04 1999
***************
*** 231,240 ****
--- 231,247 ----
  
        if (structfile)
  	{
+ 	  char buff [256];
  	  write_longdocs (structfile, saved_builtins);
  	  fclose (structfile);
+ #if defined (VMS)
+ 	  sprintf (buff, "rename %s. %s",
+ 		   temp_struct_filename, struct_filename);
+ 	  system (buff);
+ #else
  	  link (temp_struct_filename, struct_filename);
  	  unlink (temp_struct_filename);
+ #endif
  	}
  
        if (externfile)
***************
*** 500,506 ****
  		  else
  		    fprintf (defs->output, "#line %d \"%s%s\"\n",
  			     defs->line_number + 1,
! 			     error_directory ? error_directory : "./",
  			     defs->filename);
  		  output_cpp_line_info = 0;
  		}
--- 507,513 ----
  		  else
  		    fprintf (defs->output, "#line %d \"%s%s\"\n",
  			     defs->line_number + 1,
! 			     error_directory ? error_directory : "",
  			     defs->filename);
  		  output_cpp_line_info = 0;
  		}
***************
*** 840,846 ****
       char *format, *arg1, *arg2;
  {
    if (defs->filename[0] != '/')
!     fprintf (stderr, "%s", error_directory ? error_directory : "./");
    fprintf (stderr, "%s:%d:", defs->filename, defs->line_number + 1);
    fprintf (stderr, format, arg1, arg2);
    fprintf (stderr, "\n");
--- 847,853 ----
       char *format, *arg1, *arg2;
  {
    if (defs->filename[0] != '/')
!     fprintf (stderr, "%s", error_directory ? error_directory : "");
    fprintf (stderr, "%s:%d:", defs->filename, defs->line_number + 1);
    fprintf (stderr, format, arg1, arg2);
    fprintf (stderr, "\n");
diff -r -c bash-1_14_7/builtins/psize.sh bash1147/builtins/psize.sh
*** bash-1_14_7/builtins/psize.sh	Wed Mar 10 09:43:52 1999
--- bash1147/builtins/psize.sh	Wed Mar 10 09:45:04 1999
***************
*** 11,17 ****
  echo " */"
  echo ""
  
! ./psize.aux 2>/tmp/pipesize | sleep 3
  
  if [ -s /tmp/pipesize ]; then
  	echo "#define PIPESIZE `cat /tmp/pipesize`"
--- 11,17 ----
  echo " */"
  echo ""
  
! ./psize.exe 2>/tmp/pipesize | sleep 3
  
  if [ -s /tmp/pipesize ]; then
  	echo "#define PIPESIZE `cat /tmp/pipesize`"
diff -r -c bash-1_14_7/builtins/source.def bash1147/builtins/source.def
*** bash-1_14_7/builtins/source.def	Wed Mar 10 09:43:52 1999
--- bash1147/builtins/source.def	Wed Mar 10 09:45:05 1999
***************
*** 98,104 ****
      {
        char *string, *filename;
        struct stat finfo;
!       int fd, tt;
  
        filename = find_path_file (list->word->word);
        if (!filename)
--- 98,104 ----
      {
        char *string, *filename;
        struct stat finfo;
!       int fd, tt, pos;
  
        filename = find_path_file (list->word->word);
        if (!filename)
***************
*** 108,120 ****
  	goto file_error_exit;
  
        string = (char *)xmalloc (1 + (int)finfo.st_size);
!       tt = read (fd, string, finfo.st_size);
!       string[finfo.st_size] = '\0';
  
        /* Close the open file, preserving the state of errno. */
        { int temp = errno; close (fd); errno = temp; }
  
        if (tt != finfo.st_size)
  	{
  	  free (string);
  
--- 108,127 ----
  	goto file_error_exit;
  
        string = (char *)xmalloc (1 + (int)finfo.st_size);
!       pos = 0;
!       while ((tt = read (fd, &string [pos], finfo.st_size)) > 0)
! 	pos += tt;
!       string [pos] = '\0';
!       tt = pos;
  
        /* Close the open file, preserving the state of errno. */
        { int temp = errno; close (fd); errno = temp; }
  
+ #if defined (USE_VMS)
+       if (tt < 0)
+ #else
        if (tt != finfo.st_size)
+ #endif
  	{
  	  free (string);
  
diff -r -c bash-1_14_7/builtins/ulimit.def bash1147/builtins/ulimit.def
*** bash-1_14_7/builtins/ulimit.def	Wed Mar 10 09:43:53 1999
--- bash1147/builtins/ulimit.def	Wed Mar 10 09:45:06 1999
***************
*** 52,59 ****
--- 52,63 ----
  $END
  
  #include <stdio.h>
+ #ifdef VMS
+ #include <types.h>
+ #else
  #include <sys/types.h>
  #include <sys/param.h>
+ #endif
  #include <errno.h>
  #include "../shell.h"
  #include "pipesize.h"
***************
*** 138,143 ****
--- 142,151 ----
  static void print_all_limits ();
  
  static char t[2];
+ 
+ #if defined (USE_VMS)
+ static RLIMTYPE ulimit () {return 0;}
+ #endif
  
  /* Return 1 if the limit associated with CMD can be raised from CURRENT
     to NEW.  This is for USG systems without HAVE_RESOURCE, most of which
diff -r -c bash-1_14_7/command.h bash1147/command.h
*** bash-1_14_7/command.h	Wed Mar 10 09:43:45 1999
--- bash1147/command.h	Wed Mar 10 09:44:52 1999
***************
*** 45,50 ****
--- 45,53 ----
  			   or backslash is present. */
    int assignment;	/* Non-zero means that this word contains an
  			   assignment. */
+ #if defined (USE_VMS)
+   int expansion;	/* path expansion for "/" and "//x/" */
+ #endif
  } WORD_DESC;
  
  /* A linked list of words. */
diff -r -c bash-1_14_7/config.h bash1147/config.h
*** bash-1_14_7/config.h	Wed Mar 10 09:43:45 1999
--- bash1147/config.h	Wed Mar 10 09:44:52 1999
***************
*** 47,52 ****
--- 47,56 ----
  #  endif /* !_POSIX_JOB_CONTROL */
  #endif /* USG || Minix || MINIX */
  
+ #if defined (USE_VMS)
+ #  undef JOB_CONTROL
+ #endif
+ 
  /* Define ALIAS if you want the alias features. */
  #define ALIAS
  
***************
*** 89,96 ****
--- 93,105 ----
  #endif
  
  /* The default value of the PATH variable. */
+ #if defined (USE_VMS)
+ #define DEFAULT_PATH_VALUE \
+   "/gnu/bin:/bin:."
+ #else
  #define DEFAULT_PATH_VALUE \
    "/usr/gnu/bin:/usr/local/bin:/usr/ucb:/bin:/usr/bin:."
+ #endif
  
  /* The value for PATH when invoking `command -p'.  This is only used when
     the Posix.2 confstr () function, or CS_PATH define are not present. */
